<template>
  <div class="item">
    <div class="normal" v-show="!editMode">
      <h3 ref="title">{{ data.title }}</h3>
      <label><input type="checkbox" v-on:click="markItem()"></label>
      <button v-on:click="deleteItem()" title="Delete">
        <svg width="1792" height="1792" viewBox="0 0 1792 1792" xmlns="http://www.w3.org/2000/svg"><path d="M704 1376v-704q0-14-9-23t-23-9h-64q-14 0-23 9t-9 23v704q0 14 9 23t23 9h64q14 0 23-9t9-23zm256 0v-704q0-14-9-23t-23-9h-64q-14 0-23 9t-9 23v704q0 14 9 23t23 9h64q14 0 23-9t9-23zm256 0v-704q0-14-9-23t-23-9h-64q-14 0-23 9t-9 23v704q0 14 9 23t23 9h64q14 0 23-9t9-23zm-544-992h448l-48-117q-7-9-17-11h-317q-10 2-17 11zm928 32v64q0 14-9 23t-23 9h-96v948q0 83-47 143.5t-113 60.5h-832q-66 0-113-58.5t-47-141.5v-952h-96q-14 0-23-9t-9-23v-64q0-14 9-23t23-9h309l70-167q15-37 54-63t79-26h320q40 0 79 26t54 63l70 167h309q14 0 23 9t9 23z"/></svg>
        <span>Delete</span>
      </button>
    </div>
    <div class="edit" v-show="editMode">
      <form novalidate v-on:submit.prevent="editMode = false">
        <input v-model="data.title" name="title" v-bind:autofocus="editMode"
               v-on:keyup="handleKey($event)" placeholder="Write item name">
      </form>
    </div>
  </div>
</template>

<script>
import * as Hammer from 'hammerjs';
import ListService from '../list-service';

export default {
  name: 'item',
  props: ['data', 'edit', 'on-create', 'on-remove'],
  data() {
    return {
      editMode: false
    };
  },
  methods: {
    editItem() {
      this.editMode = true;
      setTimeout(() => this.$el.querySelector('[name=title]').focus(), 0);
    },
    markItem() {
      this.$el.classList.add('marked');

      ListService.marked.push(this.data);

      setTimeout(() => this.deleteItem(), 1000);
    },
    deleteItem() {
      const idx = ListService.items.indexOf(this.data);

      if (idx !== -1) {
        ListService.items.splice(idx, 1);
      }
    },
    handleKey(evt) {
      const keyCode = evt.keyCode || evt.which;

      if (keyCode === 27) {
        this.editMode = false;

        if (!this.data.title) {
          this.deleteItem();
        }
      }
    }
  },
  beforeMount() {
    if (this.onCreate) {
      this.onCreate(this);
    }
  },
  beforeDestroy() {
    if (this.onRemove) {
      this.onRemove(this);
    }
  },
  mounted() {
    const normalEl = this.$el.querySelector('.normal');

    const hammered = new Hammer.Manager(normalEl);
    hammered.add(new Hammer.Pan({
      direction: Hammer.DIRECTION_LEFT,
      threshold: 20
    }));
    hammered.add(new Hammer.Tap());

    hammered.on('pan', () => {
      const doc = document.documentElement || document.body;
      const width = doc.innerWidth || doc.clientWidth;

      // only use swipe in mobile view
      if (width <= 600) {
        // disable edit mode in all items
        this.$emit('disableEdit');

        normalEl.classList.add('show-delete');
      }
    });

    hammered.on('tap', (evt) => {
      if (normalEl.classList.contains('show-delete')) {
        normalEl.classList.remove('show-delete');
      } else if (evt.target === this.$refs.title) {
        this.editItem();
      }
    });

    // set to edit mode if edit=true
    if (this.edit) {
      // disable edit mode in other items
      this.$emit('disableEdit');

      this.editItem();
    }
  }
};
</script>

<style scoped lang="scss">
.item {
  border-bottom: 1px solid #ccc;

  @media(max-width: 600px) {
    overflow: hidden;
  }

  transition: opacity 0.5s;

  &.marked {
    pointer-events: none;
    opacity: 0.3;

    h3 {
      text-decoration: line-through;
    }
  }
}

.normal {
  display: flex;
  flex-flow: row nowrap;
  position: relative;

  @media(min-width: 601px) {
    button {
      position: absolute;
      top: 0;
      bottom: 0;
      left: 100%;
      width: 40px;
      margin-right: -40px;
      display: none;
      background: none;
      cursor: pointer;

      span {
        display: none;
      }

      svg {
        fill: #c00;
        width: 20px;
        height: 20px;
      }
    }

    &:hover {
      button {
        display: block;
      }
    }
  }

  @media(max-width: 600px) {
    button {
      width: 100px;
      margin-right: -100px;
      transition: margin 200ms;
      background: #c00;
      color: #fff;

      svg {
        display: none;
      }
    }

    transition: transform 200ms;

    &.show-delete {
      transform: translateX(-100px);
    }
  }
}

.edit {
  input {
    border: 0;
    padding: 8px;
    width: 100%;
    outline: 0;
  }
}

h3 {
  flex: 1;
  margin: 0;
  padding: 8px;
  font: bold 16px Helvetica, Arial, sans-serif;
}

label {
  padding: 8px;
}
</style>
